Subject: [bug#44199] Info: Rehash Project

From: Maxime Devos <[email-masked]>
Date: Wed, 27 Jan 2021 14:07:02 +0100

Hi Matias (and Guix, which I've CC'ed),

To Matias: a follow up message will follow.

Unfortunately, I've just taken a pause from Guix+GNUnet hacking
(though probably I'll occasionally resume hacking once in a while).

Some things that work now:

* The rehash service itself seems to work
(https://notabug.org/mdevos/rehash).
This is the service where peers add SHA512<->GNUnet FS URI mappings they
discover (replace SHA512 by whatever Guix uses).

* Unless I broke anything, the ‘remirror’ service
(actually just a daemon implementing a web
server to run locally) can proxy http: downloads.
Proxying https: is a little difficult, as ‘remirror’
would need to play man-in-the-middle, but
may be implemented eventually. Or maybe guix can
be patched to (optionally) not use the CONNECT method
for proxying https: downloads.

There is no ‘offloading’ to GNUnet yet, though.

* Perhaps a better approach for substitutes:

In the ‘scheme-gnunet’ repository (https://notabug.org/mdevos/scheme-gnunet/src/master/ROADMAP.org),
I've written a publish-store.scm and download-store.scm script,
that respectively upload and download an item
from the store/GNUnet FS (using the gnunet-publish and
gnunet-download binaries).

It's not plugged into the guix substituter
and guix publish yet, though. I'm a bit at a loss how to do this properly,
so I'm more-or-less waiting until (a future revision of) the IPFS patch
is merged, and then I'll try to add GNUnet as ‘just another p2p system’.

Greetings, Maxime
-- 
Maxime Devos <[email-masked]>
PGP Key: C1F3 3EE2 0C52 8FDB 7DD7  011F 49E3 EE22 1917 25EE
Freenode handle: mdevos